import 'dart:convert';

import 'package:camera_kit_ext/CameraKitExtController.dart';
import 'package:camera_kit_ext/CameraKitExtView.dart';
import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:camera_kit_ext/camera_kit_ext.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';
  CameraKitExtController controller = CameraKitExtController();

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    // We also handle the message potentially returning null.
    try {
      // CameraKitExt.platformVersion
      // platformVersion =await CameraKitExtController().processOCR(path: 'Asdad')??"error";
          // await CameraKitExt.platformVersion ?? 'Unknown platform version';
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      // _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        // body: Container(),

        body: Column(
          children: [
            TextButton(onPressed: () async {
              String path = await controller.takePicture()??"";
              String? a =await controller.processOCR(path: path);
              Map<String,dynamic> data = jsonDecode(a!);
              print(data["text"]);
            }, child: Text("PROS")),
            Expanded(
              child: CameraKitExtView(
                hasBarcodeReader: true,
                cameraKitController: controller,
                onBarcodeRead: (b){
                  print(b);
                },
              ),
            ),
          ],
        ),
      ),
    );
  }
}
